#ifndef __C_HASH__
#define __C_HASH__

#include "types.h"

typedef enum { UNUSED_HASH = 0, FAIL_LOW, FAIL_HIGH, EXACT } node_type;

#pragma pack(1)

class HashEntry {
public:
	/*
	HASHCODE position;	// position hashcode
	unsigned char pos[6];	// codified hashcode
	char flag;	
	char age;
	int score;	
	short int depth;
	int move;
	*/

	HASHCODE qword;			// hashcode : bits 0..47, age : 48..50 depth : 51..63
	unsigned int word1;		// move : bits 0..20, flag bits 22 .. 23
	int score;



	/*
	int key;		// id key
	int val;		// value
	int type;		// upper/lower bound (node type)
	int move;		// best move
	int depth;		// search depth to which the value was computed
	int time;		// time stamp - not when analysing positions
	*/
};
#pragma pack()

void ResizeHT(int new_size);


void InitHT(int size); // call this first !

int ProbeHT(int& alpha, int& beta, int depth, int& score, int& hm);

void ClearHT();

void AddHT(int score, int flag, int depth, int move);


#pragma pack(1)

class PawnHashEntry {
public:
	HASHCODE hashcode;
	int pawns_on_files;
	short int pawn_score;
	short int kside_defects[2];
	short int qside_defects[2];
	BITBOARD passed_pawns;
};
#pragma pack()


void AddPawnHT(PawnHashEntry& phash);
PawnHashEntry* ProbePawnHT();
void ClearPawnHT();

void PawnHTOccupied(int& full, int& total);


#endif
