#include "tree.h"
#include "board.h"
#include <string.h>

TreeEntry tree[128];

static TreeEntry move_tree[128];


void SaveBoardInfo(int ply){
	tree[ply].ep_square = board.ep_square;
	tree[ply].hashcode = board.hashcode;
	tree[ply].pawn_hashcode = board.pawn_hashcode;
	tree[ply].castle_flags = board.castle_flags;
}

void RestoreBoardInfo(int ply){
	board.ep_square = tree[ply].ep_square;
	board.hashcode = tree[ply].hashcode;
	board.pawn_hashcode = tree[ply].pawn_hashcode;
	board.castle_flags = tree[ply].castle_flags;
}

void SaveBoardInfo_forMove(int n){
	move_tree[n].ep_square = board.ep_square;
	move_tree[n].hashcode = board.hashcode;
	move_tree[n].pawn_hashcode = board.pawn_hashcode;
	move_tree[n].castle_flags = board.castle_flags;
}

void RestoreBoardInfo_forMove(int n){
	board.ep_square = move_tree[n].ep_square;
	board.hashcode = move_tree[n].hashcode;
	board.pawn_hashcode = move_tree[n].pawn_hashcode;
	board.castle_flags = move_tree[n].castle_flags;

	// the following is necessary because Unmake() calls RestoreBoardInfo(ply)
	// and since this Restore(...) will be called from movelist.cpp only
	// with ply == 0
	tree[0] = move_tree[n];
}


TreeEntry backup_tree[128];

SaveInfo backup_info[128];

void BackupTree(int maxply){ // used in book.cpp for scoring moves
	if (maxply > 128) maxply = 128;
	memcpy(backup_tree, tree, sizeof(TreeEntry)*maxply);
	memcpy(backup_info, save_struct, sizeof(SaveInfo)*maxply);
}

void RestoreTree(int maxply){
	if (maxply > 128) maxply = 128;
	memcpy(tree, backup_tree, sizeof(TreeEntry)*maxply);
	memcpy(save_struct, backup_info, sizeof(SaveInfo)*maxply);
}


